#include <windows.h>
#include <stdio.h>
#include <gl\gl.h>
#include <gl\glu.h>
#include "texture.h"

bool LoadTGA(Texture *, char *);								// Function Prototype For LoadTGA ( NEW )

extern HDC			hDC;											// Private GDI Device Context
extern HGLRC		hRC;											// Permanent Rendering Context
extern HWND		hWnd;											// Holds Our Window Handle
extern HINSTANCE	hInstance;											// Holds The Instance Of The Application

extern bool	keys[256];												// Array Used For The Keyboard Routine
bool	active=TRUE;											// Window Active Flag Set To TRUE By Default
bool	fullscreen=TRUE;										// Fullscreen Flag Set To Fullscreen Mode By Default

float	spin;													// Spin Variable

Texture texture[2];												// Storage For 2 Textures ( NEW )
extern ABITMAP *screen;

LRESULT	CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);			// Declaration For WndProc


int LoadGLTextures()											// Load Bitmaps And Convert To Textures
{
	int Status=FALSE;											// Status Indicator

	// Load The Bitmap, Check For Errors.
	if (LoadTGA(&texture[0], "Data/Uncompressed.tga") &&
		LoadTGA(&texture[1], "Data/Compressed.tga"))
	{
		//clear(&texture[1]); 
		//blit(&texture[0], &texture[1], 5, 5, 10, 10, 170, 170, 1, 200);
		//draw_sprite(&texture[1], &texture[0], 10, 10);
		/*
		for(int x = 0; x < texture[1].w; x++) {
			for(int y = 0; y < texture[1].h; y++) {
				putpixel(&(texture[1]), x, y, makecol(rand() % 255, rand() % 255, rand() % 255));
			}
		}
		*/

		Status=TRUE;											// Set The Status To TRUE

		for (int loop=0; loop<2; loop++)						// Loop Through Both Textures
		{
			// Typical Texture Generation Using Data From The TGA ( CHANGE )
			glGenTextures(1, &texture[loop].texID);				// Create The Texture ( CHANGE )
			glBindTexture(GL_TEXTURE_2D, texture[loop].texID);
			glTexImage2D(GL_TEXTURE_2D, 0, 3, texture[loop].width, texture[loop].height, 0, GL_RGB, GL_UNSIGNED_BYTE, texture[loop].imageData);
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);

			if (texture[loop].imageData)						// If Texture Image Exists ( CHANGE )
			{
				free(texture[loop].imageData);					// Free The Texture Image Memory ( CHANGE )
			}
		}
	}
	return Status;												// Return The Status
}

GLvoid ReSizeGLScene(GLsizei width, GLsizei height)				// Resize And Initialize The GL Window
{
	/*
	int w = 640;
	int h = 480;
	glViewport(0, 0, w, h);

    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    // We set up coordinate system so that aspect ratios are always correct,
    //  and the region from -1..1 in x & y always just fits in the viewport.
    if (w > h)
    {
       gluOrtho2D(-double(w)/h, double(w)/h, -1., 1.);
    }
    else
    {
       gluOrtho2D( -1., 1., -double(h)/w, double(h)/w);
    }

    glMatrixMode(GL_MODELVIEW);  // Always go back to modelview mode
    glLoadIdentity();

	return;
	*/

	if (height==0)												// Prevent A Divide By Zero By
	{
		height=1;												// Making Height Equal One
	}

	glViewport(0,0,width,height);								// Reset The Current Viewport

	glMatrixMode(GL_PROJECTION);								// Select The Projection Matrix
	glLoadIdentity();											// Reset The Projection Matrix

	glOrtho(0.0f,width,height,0.0f,-1.0f,1.0f);					// Create Ortho 640x480 View (0,0 At Top Left)

	glMatrixMode(GL_MODELVIEW);									// Select The Modelview Matrix
	glLoadIdentity();											// Reset The Modelview Matrix
}

int InitGL(GLvoid)												// All Setup For OpenGL Goes Here
{
	if (!LoadGLTextures())										// Jump To Texture Loading Routine ( NEW )
	{
		return FALSE;											// If Texture Didn't Load Return FALSE
	}

	//glEnable(GL_TEXTURE_2D);
	glShadeModel(GL_SMOOTH);									// Enable Smooth Shading
	glClearColor(0.0f, 0.0f, 0.0f, 0.0f);						// Black Background
	glClearDepth(1.0f);											// Depth Buffer Setup
	glHint(GL_LINE_SMOOTH_HINT, GL_NICEST);						// Set Line Antialiasing
	glEnable(GL_BLEND);											// Enable Blending
	//glAlphaFunc(GL_GREATER,0.1f);
	//glEnable(GL_ALPHA_TEST);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);			// Type Of Blending To Use
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
	//glEnable(GL_CULL_FACE);
	glEnable(GL_LINE_SMOOTH);
	glEnable(GL_POINT_SMOOTH);
	glPointSize(40);
	
	return TRUE;												// Initialization Went OK
}

int DrawGLScene(GLvoid)											// Here's Where We Do All The Drawing
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);			// Clear The Screen And The Depth Buffer
	glLoadIdentity();											// Reset The Modelview Matrix
	glTranslatef(0.0f,0.0f,-3.0f);								// Translate 20 Units Into The Screen

	spin+=0.05f;												// Increase Spin

	glPushMatrix();											// Push The Matrix
	
	glBindTexture(GL_TEXTURE_2D, texture[0].texID);			// ( CHANGE )
	glBegin(GL_QUADS);										// Draw Our Quad
		glTexCoord2f(0.0f, 1.0f); glVertex3f(-1.0f,  1.0f, 0.0f);
		glTexCoord2f(1.0f, 1.0f); glVertex3f( 1.0f,  1.0f, 0.0f);
		glTexCoord2f(1.0f, 0.0f); glVertex3f( 1.0f, -1.0f, 0.0f);
		glTexCoord2f(0.0f, 0.0f); glVertex3f(-1.0f, -1.0f, 0.0f);
	glEnd();												// Done Drawing The Quad
	glPopMatrix();											// Pop The Matrix
	
	/*
	glPushMatrix();											// Push The Matrix
	glTranslatef(2.0f,0.0f,0.0f);							// Translate 2 Units To The Right
	glRotatef(spin+loop*36.0f,0.0f,1.0f,0.0f);				// Rotate On The Y-Axis (Left - Right)
	glTranslatef(1.0f,0.0f,0.0f);							// Move One Unit Right

	glBindTexture(GL_TEXTURE_2D, texture[1].texID);			// ( CHANGE )
	glBegin(GL_QUADS);										// Draw Our Quad
		glTexCoord2f(0.0f, 0.0f); glVertex3f(-1.0f,  1.0f, 0.0f);
		glTexCoord2f(1.0f, 0.0f); glVertex3f( 1.0f,  1.0f, 0.0f);
		glTexCoord2f(1.0f, 1.0f); glVertex3f( 1.0f, -1.0f, 0.0f);
		glTexCoord2f(0.0f, 1.0f); glVertex3f(-1.0f, -1.0f, 0.0f);
	glEnd();												// Done Drawing The Quad
	glPopMatrix();
	*/
	/*
	for (int loop=0; loop<20; loop++)							// Loop Of 20
	{
		glPushMatrix();											// Push The Matrix
		glRotatef(spin+loop*18.0f,1.0f,0.0f,0.0f);				// Rotate On The X-Axis (Up - Down)
		glTranslatef(-2.0f,2.0f,0.0f);							// Translate 2 Units Left And 2 Up

		glBindTexture(GL_TEXTURE_2D, texture[0].texID);			// ( CHANGE )
		glBegin(GL_QUADS);										// Draw Our Quad
			glTexCoord2f(0.0f, 1.0f); glVertex3f(-1.0f,  1.0f, 0.0f);
			glTexCoord2f(1.0f, 1.0f); glVertex3f( 1.0f,  1.0f, 0.0f);
			glTexCoord2f(1.0f, 0.0f); glVertex3f( 1.0f, -1.0f, 0.0f);
			glTexCoord2f(0.0f, 0.0f); glVertex3f(-1.0f, -1.0f, 0.0f);
		glEnd();												// Done Drawing The Quad
		glPopMatrix();											// Pop The Matrix

		glPushMatrix();											// Push The Matrix
		glTranslatef(2.0f,0.0f,0.0f);							// Translate 2 Units To The Right
		glRotatef(spin+loop*36.0f,0.0f,1.0f,0.0f);				// Rotate On The Y-Axis (Left - Right)
		glTranslatef(1.0f,0.0f,0.0f);							// Move One Unit Right

		glBindTexture(GL_TEXTURE_2D, texture[1].texID);			// ( CHANGE )
		glBegin(GL_QUADS);										// Draw Our Quad
			glTexCoord2f(0.0f, 0.0f); glVertex3f(-1.0f,  1.0f, 0.0f);
			glTexCoord2f(1.0f, 0.0f); glVertex3f( 1.0f,  1.0f, 0.0f);
			glTexCoord2f(1.0f, 1.0f); glVertex3f( 1.0f, -1.0f, 0.0f);
			glTexCoord2f(0.0f, 1.0f); glVertex3f(-1.0f, -1.0f, 0.0f);
		glEnd();												// Done Drawing The Quad
		glPopMatrix();											// Pop The Matrix
	}
	*/
	return TRUE;												// Keep Going
}

GLvoid KillGLWindow(GLvoid)										// Properly Kill The Window
{
	if (fullscreen)												// Are We In Fullscreen Mode?
	{
		ChangeDisplaySettings(NULL,0);							// If So Switch Back To The Desktop
		ShowCursor(TRUE);										// Show Mouse Pointer
	}

	if (hRC)													// Do We Have A Rendering Context?
	{
		if (!wglMakeCurrent(NULL,NULL))							// Are We Able To Release The DC And RC Contexts?
		{
			MessageBox(NULL,"Release Of DC And RC Failed.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		}

		if (!wglDeleteContext(hRC))								// Are We Able To Delete The RC?
		{
			MessageBox(NULL,"Release Rendering Context Failed.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		}
		hRC=NULL;												// Set RC To NULL
	}

	if (hDC && !ReleaseDC(hWnd,hDC))							// Are We Able To Release The DC
	{
		MessageBox(NULL,"Release Device Context Failed.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		hDC=NULL;												// Set DC To NULL
	}

	if (hWnd && !DestroyWindow(hWnd))							// Are We Able To Destroy The Window?
	{
		MessageBox(NULL,"Could Not Release hWnd.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		hWnd=NULL;												// Set hWnd To NULL
	}

	if (!UnregisterClass("OpenGL",hInstance))					// Are We Able To Unregister Class
	{
		MessageBox(NULL,"Could Not Unregister Class.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		hInstance=NULL;											// Set hInstance To NULL
	}
}

/*	This Code Creates Our OpenGL Window.  Parameters Are:					*
 *	title			- Title To Appear At The Top Of The Window				*
 *	width			- Width Of The GL Window Or Fullscreen Mode				*
 *	height			- Height Of The GL Window Or Fullscreen Mode			*
 *	bits			- Number Of Bits To Use For Color (8/16/24/32)			*
 *	fullscreenflag	- Use Fullscreen Mode (TRUE) Or Windowed Mode (FALSE)	*/
 
BOOL CreateGLWindow(char* title, int width, int height, int bits, bool fullscreenflag)
{
	GLuint		PixelFormat;									// Holds The Results After Searching For A Match
	WNDCLASS	wc;												// Windows Class Structure
	DWORD		dwExStyle;										// Window Extended Style
	DWORD		dwStyle;										// Window Style
	RECT		WindowRect;										// Grabs Rectangle Upper Left / Lower Right Values
	WindowRect.left=(long)0;									// Set Left Value To 0
	WindowRect.right=(long)width;								// Set Right Value To Requested Width
	WindowRect.top=(long)0;										// Set Top Value To 0
	WindowRect.bottom=(long)height;								// Set Bottom Value To Requested Height

	fullscreen=fullscreenflag;									// Set The Global Fullscreen Flag

	hInstance			= GetModuleHandle(NULL);				// Grab An Instance For Our Window
	wc.style			= CS_HREDRAW | CS_VREDRAW | CS_OWNDC;	// Redraw On Size, And Own DC For Window.
	wc.lpfnWndProc		= (WNDPROC) WndProc;					// WndProc Handles Messages
	wc.cbClsExtra		= 0;									// No Extra Window Data
	wc.cbWndExtra		= 0;									// No Extra Window Data
	wc.hInstance		= hInstance;							// Set The Instance
	wc.hIcon			= LoadIcon(NULL, IDI_WINLOGO);			// Load The Default Icon
	wc.hCursor			= LoadCursor(NULL, IDC_ARROW);			// Load The Arrow Pointer
	wc.hbrBackground	= NULL;									// No Background Required For GL
	wc.lpszMenuName		= NULL;									// We Don't Want A Menu
	wc.lpszClassName	= "OpenGL";								// Set The Class Name

	if (!RegisterClass(&wc))									// Attempt To Register The Window Class
	{
		MessageBox(NULL,"Failed To Register The Window Class.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;											// Return FALSE
	}
	
	if (fullscreen)												// Attempt Fullscreen Mode?
	{
		DEVMODE dmScreenSettings;								// Device Mode
		memset(&dmScreenSettings,0,sizeof(dmScreenSettings));	// Makes Sure Memory's Cleared
		dmScreenSettings.dmSize=sizeof(dmScreenSettings);		// Size Of The Devmode Structure
		dmScreenSettings.dmPelsWidth	= width;				// Selected Screen Width
		dmScreenSettings.dmPelsHeight	= height;				// Selected Screen Height
		dmScreenSettings.dmBitsPerPel	= bits;					// Selected Bits Per Pixel
		dmScreenSettings.dmFields=DM_BITSPERPEL|DM_PELSWIDTH|DM_PELSHEIGHT;

		// Try To Set Selected Mode And Get Results.  NOTE: CDS_FULLSCREEN Gets Rid Of Start Bar.
		if (ChangeDisplaySettings(&dmScreenSettings,CDS_FULLSCREEN)!=DISP_CHANGE_SUCCESSFUL)
		{
			// If The Mode Fails, Offer Two Options.  Quit Or Use Windowed Mode.
			if (MessageBox(NULL,"The Requested Fullscreen Mode Is Not Supported By\nYour Video Card. Use Windowed Mode Instead?","NeHe GL",MB_YESNO|MB_ICONEXCLAMATION)==IDYES)
			{
				fullscreen=FALSE;								// Windowed Mode Selected.  Fullscreen = FALSE
			}
			else
			{
				// Pop Up A Message Box Letting User Know The Program Is Closing.
				MessageBox(NULL,"Program Will Now Close.","ERROR",MB_OK|MB_ICONSTOP);
				return FALSE;									// Return FALSE
			}
		}
	}

	if (fullscreen)												// Are We Still In Fullscreen Mode?
	{
		dwExStyle=WS_EX_APPWINDOW;								// Window Extended Style
		dwStyle=WS_POPUP;										// Windows Style
		ShowCursor(FALSE);										// Hide Mouse Pointer
	}
	else
	{
		dwExStyle=WS_EX_APPWINDOW | WS_EX_WINDOWEDGE;			// Window Extended Style
		dwStyle=WS_POPUP;//WS_OVERLAPPEDWINDOW;					// Windows Style
		ShowCursor(FALSE);										// Hide Mouse Pointer
	}

	AdjustWindowRectEx(&WindowRect, dwStyle, FALSE, dwExStyle);	// Adjust Window To True Requested Size

	// Create The Window
	if (!(hWnd=CreateWindowEx(	dwExStyle,							// Extended Style For The Window
								"OpenGL",							// Class Name
								title,								// Window Title
								dwStyle |							// Defined Window Style
								WS_CLIPSIBLINGS |					// Required Window Style
								WS_CLIPCHILDREN,					// Required Window Style
								0, 0,								// Window Position
								WindowRect.right-WindowRect.left,	// Calculate Window Width
								WindowRect.bottom-WindowRect.top,	// Calculate Window Height
								NULL,								// No Parent Window
								NULL,								// No Menu
								hInstance,							// Instance
								NULL)))								// Dont Pass Anything To WM_CREATE
	{
		KillGLWindow();											// Reset The Display
		MessageBox(NULL,"Window Creation Error.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;											// Return FALSE
	}

	static	PIXELFORMATDESCRIPTOR pfd=							// pfd Tells Windows How We Want Things To Be
	{
		sizeof(PIXELFORMATDESCRIPTOR),							// Size Of This Pixel Format Descriptor
		1,														// Version Number
		PFD_DRAW_TO_WINDOW |									// Format Must Support Window
		PFD_SUPPORT_OPENGL |									// Format Must Support OpenGL
		PFD_DOUBLEBUFFER,										// Must Support Double Buffering
		PFD_TYPE_RGBA,											// Request An RGBA Format
		bits,													// Select Our Color Depth
		0, 0, 0, 0, 0, 0,										// Color Bits Ignored
		0,														// No Alpha Buffer
		0,														// Shift Bit Ignored
		0,														// No Accumulation Buffer
		0, 0, 0, 0,												// Accumulation Bits Ignored
		16,														// 16Bit Z-Buffer (Depth Buffer)  
		0,														// No Stencil Buffer
		0,														// No Auxiliary Buffer
		PFD_MAIN_PLANE,											// Main Drawing Layer
		0,														// Reserved
		0, 0, 0													// Layer Masks Ignored
	};
	
	if (!(hDC=GetDC(hWnd)))										// Did We Get A Device Context?
	{
		KillGLWindow();											// Reset The Display
		MessageBox(NULL,"Can't Create A GL Device Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;											// Return FALSE
	}

	if (!(PixelFormat=ChoosePixelFormat(hDC,&pfd)))				// Did Windows Find A Matching Pixel Format?
	{
		KillGLWindow();											// Reset The Display
		MessageBox(NULL,"Can't Find A Suitable PixelFormat.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;											// Return FALSE
	}

	if(!SetPixelFormat(hDC,PixelFormat,&pfd))					// Are We Able To Set The Pixel Format?
	{
		KillGLWindow();											// Reset The Display
		MessageBox(NULL,"Can't Set The PixelFormat.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;											// Return FALSE
	}

	if (!(hRC=wglCreateContext(hDC)))							// Are We Able To Get A Rendering Context?
	{
		KillGLWindow();											// Reset The Display
		MessageBox(NULL,"Can't Create A GL Rendering Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;											// Return FALSE
	}

	if(!wglMakeCurrent(hDC,hRC))								// Try To Activate The Rendering Context
	{
		KillGLWindow();											// Reset The Display
		MessageBox(NULL,"Can't Activate The GL Rendering Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;											// Return FALSE
	}

	ShowWindow(hWnd,SW_SHOW);									// Show The Window
	SetForegroundWindow(hWnd);									// Slightly Higher Priority
	SetFocus(hWnd);												// Sets Keyboard Focus To The Window
	ReSizeGLScene(width, height);								// Set Up Our Perspective GL Screen

	if (!InitGL())												// Initialize Our Newly Created GL Window
	{
		KillGLWindow();											// Reset The Display
		MessageBox(NULL,"Initialization Failed.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;											// Return FALSE
	}

	return TRUE;												// Success
}

LRESULT CALLBACK WndProc(	HWND	hWnd,						// Handle For This Window
							UINT	uMsg,						// Message For This Window
							WPARAM	wParam,						// Additional Message Information
							LPARAM	lParam)						// Additional Message Information
{
	switch (uMsg)												// Check For Windows Messages
	{
		case WM_ACTIVATE:										// Watch For Window Activate Message
		{
			if (!HIWORD(wParam))								// Check Minimization State
			{
				active=TRUE;									// Program Is Active
			}
			else
			{
				active=FALSE;									// Program Is No Longer Active
			}

			return 0;											// Return To The Message Loop
		}

		case WM_SYSCOMMAND:										// Intercept System Commands
		{
			switch (wParam)										// Check System Calls
			{
				case SC_SCREENSAVE:								// Screensaver Trying To Start?
				case SC_MONITORPOWER:							// Monitor Trying To Enter Powersave?
				return 0;										// Prevent From Happening
			}
			break;												// Exit
		}

		case WM_CLOSE:											// Did We Receive A Close Message?
		{
			PostQuitMessage(0);									// Send A Quit Message
			return 0;											// Jump Back
		}

		case WM_KEYDOWN:										// Is A Key Being Held Down?
		{
			if(selectedlabel != NULL && selectedlabel->editable && selectedlabel->parent->on && wParam != VK_ESCAPE && wParam != VK_SHIFT) {
				int i;
				if(wParam == VK_BACK) {
					for(i = 0; i < 1000 && selectedlabel->contents[i] != '\0'; i++) ;
					if(i > 0)
						selectedlabel->contents[i-1] = '\0';
				}
				else if(wParam == VK_RETURN) {
					deselectlabel();
				}
				else {
					for(i = 0; i < 999 && selectedlabel->contents[i] != '\0'; i++) ;
					if(wParam >= 'A' && wParam <= 'Z') {
						if(keys[VK_SHIFT])
							selectedlabel->contents[i] = wParam;
						else
							selectedlabel->contents[i] = wParam + ('a' - 'A');
						selectedlabel->contents[i+1] = '\0';
					}
					else if(wParam == VK_SPACE) {
						selectedlabel->contents[i] = wParam;
						selectedlabel->contents[i+1] = '\0';
					}
				}
				return 0;
			}

			keys[wParam] = TRUE;								// If So, Mark It As TRUE
			/*
			if(wParam == VK_ESCAPE) {
				if(menumode == 1)
					menumode = 0;
				else
					menumode = -7;
			}
			else if(menumode == 0)
				menumode = 1;
				*/
			if(wParam == VK_ESCAPE && menumode != -1)
				menumode = -7;
			return 0;											// Jump Back
		}

		case WM_KEYUP:											// Has A Key Been Released?
		{
			keys[wParam] = FALSE;								// If So, Mark It As FALSE
			return 0;											// Jump Back
		}

		case WM_SIZE:											// Resize The OpenGL Window
		{
			ReSizeGLScene(LOWORD(lParam),HIWORD(lParam));		// LoWord=Width, HiWord=Height
			return 0;											// Jump Back
		}

		case WM_LBUTTONDOWN:
		{
			/* if we don't set the capture we won't get mouse move
				messages when the mouse moves outside the window. */
			SetCapture(hWnd);
			mouse_x = LOWORD(lParam);
			mouse_y = HIWORD(lParam);
			buttonpressed = false;
			msdownbuttons();
			if(level == -1 && !buttonpressed) {
				createexplosion(mouse_x + lx, mouse_y);
			}
			mx = mouse_x + lx;
			my = mouse_y;
			lmb = true;

			if(level == 10 || level == 11) {
				addbox(mx - 32, my - 32);
			}

			return 0;
		}

		case WM_RBUTTONDOWN:
		{
			SetCapture(hWnd);
			mouse_x = LOWORD(lParam);
			mouse_y = HIWORD(lParam);
			rmb = true;
			return 0;
		}

		case WM_LBUTTONUP:
		{
			ReleaseCapture();
			msupbuttons();
			lmb = false;
			/*
			if(level == -1) {
				menuatom->level = 0;
				for(int i = 0; i < MAXLEVELS; i++)
					menuatom->levels[i] = false;
			}
			*/
			return 0;
		}
		
		case WM_RBUTTONUP:
		{
			ReleaseCapture();
			rmb = false;
			return 0;
		}

		case WM_MOUSEMOVE:
		{
			mouse_x = LOWORD(lParam);
			mouse_y = HIWORD(lParam);
			/* Win32 is pretty braindead about the x, y position that
			   it returns when the mouse is off the left or top edge
			   of the window (due to them being unsigned). therefore,
			   roll the Win32's 0..2^16 pointer co-ord range to the
			   more amenable (and useful) 0..+/-2^15. */
			if(mouse_x & 1 << 15) mouse_x -= (1 << 16);
			if(mouse_y & 1 << 15) mouse_y -= (1 << 16);
			return 0;
		}

	}

	// Pass All Unhandled Messages To DefWindowProc
	return DefWindowProc(hWnd,uMsg,wParam,lParam);
}

void init_graphics() {
	CreateGLWindow("GL Tests",800,600,32,fullscreen);

	//ReSizeGLScene(700, 500);

	//screen = create_bitmap(800, 600);
	//clear(screen);
}

int handlemessages(MSG &msg) {
	if (PeekMessage(&msg,NULL,0,0,PM_REMOVE)) {				// Is There A Message Waiting?
		if (msg.message==WM_QUIT) {							// Have We Received A Quit Message?
			return 2;										// If So done=TRUE
		}
		else {												// If Not, Deal With Window Messages
			TranslateMessage(&msg);							// Translate The Message
			DispatchMessage(&msg);							// Dispatch The Message
			return 1;
		}
	}
	else {
		return 0;
	}
}

void initvars() {	
	debug = fopen("debug.txt", "w");
	setbuf(debug, NULL);
	lmb = rmb = false;
}

void deinitvars() {
	fclose(debug);
}
